Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.hp.hpl.jena.reasoner
Class BaseInfGraph

    java.lang.Object
      com.hp.hpl.jena.graph.impl.GraphBase
          com.hp.hpl.jena.reasoner.BaseInfGraph

All Implemented Interfaces:
  Graph, GraphAdd, com.hp.hpl.jena.graph.impl.GraphWithPerform, InfGraph

Direct Known Subclasses:
  BasicForwardRuleInfGraph, DIGInfGraph, LPBackwardRuleInfGraph, TransitiveInfGraph

    public abstract class BaseInfGraph

extends com.hp.hpl.jena.graph.impl.GraphBase
implements InfGraph

A base level implementation of the InfGraph interface.

Version:
  $Revision: 1.48 $ on $Date: 2008/01/02 12:07:00 $
Author:
  Dave Reynolds

Nested Class Summary
`static class` | `BaseInfGraph.InfCapabilities` An InfCapabilities notes that size may not be accurate, and some triples may be irremovable.
`static class` | `BaseInfGraph.InfFindSafeCapabilities` An InfCapabilities notes that size may not be accurate, and some triples may be irremovable.
`static class` | `BaseInfGraph.InfTransactionHandler`

Field Summary

Fields inherited from interface com.hp.hpl.jena.graph.Graph
`emptyGraph`

Constructor Summary
`BaseInfGraph(Graph data, Reasoner reasoner)` Constructor
`BaseInfGraph(Graph data, Reasoner reasoner, ReificationStyle style)`

Method Summary
`InfGraph` | `cloneWithPremises(Graph premises)` Return a new inference graph which is a clone of the current graph together with an additional set of data premises.
`void` | `close()` Free all resources, any further use of this Graph is an error.
`Reifier` | `constructReifier()` Inference graphs share the reifiers of their underlying raw graphs.
`ExtendedIterator` | `find(Node subject, Node property, Node object, Graph param)` An extension of the Graph.find interface which allows the caller to encode complex expressions in RDF and then refer to those expressions within the query triple.
`ExtendedIterator` | `find(TriplePattern pattern)` Basic pattern lookup interface.
`abstract ExtendedIterator` | `findWithContinuation(TriplePattern pattern, Finder continuation)` Extended find interface used in situations where the implementator may or may not be able to answer the complete query.
`BulkUpdateHandler` | `getBulkUpdateHandler()` Answer a BulkUpdateHandler bound to this graph.
`Capabilities` | `getCapabilities()` Answer the InfCapabilities of this InfGraph.
`Graph` | `getDeductionsGraph()` Returns a derivations graph.
`java.util.Iterator` | `getDerivation(Triple triple)` Return the derivation of the given triple (which is the result of some previous find operation).
`Node` | `getGlobalProperty(Node property)` Test a global boolean property of the graph.
`PrefixMapping` | `getPrefixMapping()` Inference graphs share the prefix-mapping of their underlying raw graph.
`Graph` | `getRawGraph()` Return the raw RDF data Graph being processed (i.e. the argument to the Reasonder.bind call that created this InfGraph).
`Reasoner` | `getReasoner()` Return the Reasoner which is being used to answer queries to this graph.
`abstract Graph` | `getSchemaGraph()` Return the schema graph, if any, bound into this inference graph.
`TransactionHandler` | `getTransactionHandler()` Answer a transaction handler bound to this graph.
`int` | `getVersion()` Return a version stamp for this graph which can be used to fast-fail concurrent modification exceptions.
`ExtendedIterator` | `graphBaseFind(Node subject, Node property, Node object)` Returns an iterator over Triples.
`ExtendedIterator` | `graphBaseFind(TripleMatch m)` Returns an iterator over Triples.
`int` | `graphBaseSize()` Return the number of triples in the just the base graph
`boolean` | `isEmpty()` Answer true iff this graph is empty.
`boolean` | `isPrepared()` Answer true iff this graph has been through the `prepare()` step.
`void` | `performAdd(Triple t)` Add one triple to the data graph, run any rules triggered by the new data item, recursively adding any generated triples.
`void` | `performDelete(Triple t)` Removes the triple t (if possible) from the set belonging to this graph.
`void` | `prepare()` Perform any initial processing and caching.
`void` | `rebind()` Cause the inference graph to reconsult the underlying graph to take into account changes.
`void` | `rebind(Graph data)` Replace the underlying data graph for this inference graph and start any inferences over again.
`void` | `reset()` Reset any internal caches.
`void` | `setDerivationLogging(boolean logOn)` Switch on/off drivation logging
`boolean` | `testGlobalProperty(Node property)` A convenience version of getGlobalProperty which can only return a boolean result.
`ValidityReport` | `validate()` Test the consistency of the bound data.

Methods inherited from class com.hp.hpl.jena.graph.impl.GraphBase
`add, contains, contains, delete, dependsOn, find, find, forTestingOnly_graphBaseFind, getEventManager, getReifier, getStatisticsHandler, isClosed, isIsomorphicWith, notifyAdd, notifyDelete, queryHandler, size, toString, toString`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.hp.hpl.jena.graph.Graph
`contains, contains, delete, dependsOn, find, find, getEventManager, getReifier, getStatisticsHandler, isClosed, isIsomorphicWith, queryHandler, size`

Methods inherited from interface com.hp.hpl.jena.graph.GraphAdd
`add`

Constructor Detail

### BaseInfGraph

    public BaseInfGraph(Graph data,
                        Reasoner reasoner)

  Constructor

  Parameters:
    `data` - the raw data file to be augmented with entailments
    `reasoner` - the engine, with associated tbox data, whose find interface can be used to extract all entailments from the data.

### BaseInfGraph

    public BaseInfGraph(Graph data,
                        Reasoner reasoner,
                        ReificationStyle style)

Method Detail

### getPrefixMapping

    public PrefixMapping getPrefixMapping()

  Inference graphs share the prefix-mapping of their underlying raw graph.

  Specified by:
    `getPrefixMapping` in interface `Graph`
  Overrides:
    `getPrefixMapping` in class `com.hp.hpl.jena.graph.impl.GraphBase`
  See Also:
    `Graph.getPrefixMapping()`

### constructReifier

    public Reifier constructReifier()

  Inference graphs share the reifiers of their underlying raw graphs. This may be too simplistic - they won't see quads flying past. TODO write a test case that reveals this.

  Overrides:
    `constructReifier` in class `com.hp.hpl.jena.graph.impl.GraphBase`
  See Also:
    `Graph.getReifier()`

### getCapabilities

    public Capabilities getCapabilities()

  Answer the InfCapabilities of this InfGraph.

  Specified by:
    `getCapabilities` in interface `Graph`
  Overrides:
    `getCapabilities` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### getBulkUpdateHandler

    public BulkUpdateHandler getBulkUpdateHandler()

  Description copied from class: `com.hp.hpl.jena.graph.impl.GraphBase`
  Answer a BulkUpdateHandler bound to this graph. The default is a SimpleBulkUpdateHandler, which does bulk update by repeated simple (add/delete) updates; the same handler is returned on each call. Subclasses may override if they have specialised implementations.

  Specified by:
    `getBulkUpdateHandler` in interface `Graph`
  Overrides:
    `getBulkUpdateHandler` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### getTransactionHandler

    public TransactionHandler getTransactionHandler()

  Description copied from class: `com.hp.hpl.jena.graph.impl.GraphBase`
  Answer a transaction handler bound to this graph. The default is SimpleTransactionHandler, which handles no transactions.

  Specified by:
    `getTransactionHandler` in interface `Graph`
  Overrides:
    `getTransactionHandler` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### getRawGraph

    public Graph getRawGraph()

  Return the raw RDF data Graph being processed (i.e. the argument to the Reasonder.bind call that created this InfGraph).

  Specified by:
    `getRawGraph` in interface `InfGraph`

### getReasoner

    public Reasoner getReasoner()

  Return the Reasoner which is being used to answer queries to this graph.

  Specified by:
    `getReasoner` in interface `InfGraph`

### rebind

    public void rebind(Graph data)

  Replace the underlying data graph for this inference graph and start any inferences over again. This is primarily using in setting up ontology imports processing to allow an imports multiunion graph to be inserted between the inference graph and the raw data, before processing.

  Specified by:
    `rebind` in interface `InfGraph`
  Parameters:
    `data` - the new raw data graph

### rebind

    public void rebind()

  Cause the inference graph to reconsult the underlying graph to take into account changes. Normally changes are made through the InfGraph's add and remove calls are will be handled appropriately. However, in some cases changes are made "behind the InfGraph's back" and this forces a full reconsult of the changed data.

  Specified by:
    `rebind` in interface `InfGraph`

### reset

    public void reset()

  Reset any internal caches. Some systems, such as the tabled backchainer, retain information after each query. A reset will wipe this information preventing unbounded memory use at the expense of more expensive future queries. A reset does not cause the raw data to be reconsulted and so is less expensive than a rebind.

  Specified by:
    `reset` in interface `InfGraph`

### prepare

    public void prepare()

  Perform any initial processing and caching. This call is optional. Most engines either have negligable set up work or will perform an implicit "prepare" if necessary. The call is provided for those occasions where substantial preparation work is possible (e.g. running a forward chaining rule system) and where an application might wish greater control over when this prepration is done.

  Specified by:
    `prepare` in interface `InfGraph`

### getDeductionsGraph

    public Graph getDeductionsGraph()

  Returns a derivations graph. The rule reasoners typically create a graph containing those triples added to the base graph due to rule firings. In some applications it can useful to be able to access those deductions directly, without seeing the raw data which triggered them. In particular, this allows the forward rules to be used as if they were rewrite transformation rules.

  Specified by:
    `getDeductionsGraph` in interface `InfGraph`
  Returns:
    the deductions graph, if relevant for this class of inference engine or null if not.

### getGlobalProperty

    public Node getGlobalProperty(Node property)

  Test a global boolean property of the graph. This might included properties like consistency, OWLSyntacticValidity etc. It remains to be seen what level of generality is needed here. We could replace this by a small number of specific tests for common concepts.

  Specified by:
    `getGlobalProperty` in interface `InfGraph`
  Parameters:
    `property` - the URI of the property to be tested
  Returns:
    a Node giving the value of the global property, this may be a boolean literal, some other literal value (e.g. a size).

### testGlobalProperty

    public boolean testGlobalProperty(Node property)

  A convenience version of getGlobalProperty which can only return a boolean result.

  Specified by:
    `testGlobalProperty` in interface `InfGraph`

### validate

    public ValidityReport validate()

  Test the consistency of the bound data. This normally tests the validity of the bound instance data against the bound schema data.

  Specified by:
    `validate` in interface `InfGraph`
  Returns:
    a ValidityReport structure

### find

    public ExtendedIterator find(Node subject,
                                 Node property,
                                 Node object,
                                 Graph param)

  An extension of the Graph.find interface which allows the caller to encode complex expressions in RDF and then refer to those expressions within the query triple. For example, one might encode a class expression and then ask if there are any instances of this class expression in the InfGraph.

  Specified by:
    `find` in interface `InfGraph`
  Parameters:
    `subject` - the subject Node of the query triple, may be a Node in the graph or a node in the parameter micro-graph or null
    `property` - the property to be retrieved or null
    `object` - the object Node of the query triple, may be a Node in the graph or a node in the parameter micro-graph.
    `param` - a small graph encoding an expression which the subject and/or object nodes refer.

### graphBaseFind

    public ExtendedIterator graphBaseFind(TripleMatch m)

  Returns an iterator over Triples.

  This code used to have the .filterKeep component uncommented. We think this is because of earlier history, before .matches on a literal node was implemented as sameValueAs rather than equals. If it turns out that the filter is needed, it can be commented back in, AND a corresponding filter added to find(Node x 3) -- and test cases, of course.

  [Chris, after discussion with Dave]

  Specified by:
    `graphBaseFind` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### graphBaseFind

    public ExtendedIterator graphBaseFind(Node subject,
                                          Node property,
                                          Node object)

  Returns an iterator over Triples. This implementation assumes that the underlying findWithContinuation will have also consulted the raw data.

  Overrides:
    `graphBaseFind` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### findWithContinuation

    public abstract ExtendedIterator findWithContinuation(TriplePattern pattern,
                                                          Finder continuation)

  Extended find interface used in situations where the implementator may or may not be able to answer the complete query. It will attempt to answer the pattern but if its answers are not known to be complete then it will also pass the request on to the nested Finder to append more results.

  Parameters:
    `pattern` - a TriplePattern to be matched against the data
    `continuation` - either a Finder or a normal Graph which will be asked for additional match results if the implementor may not have completely satisfied the query.

### find

    public ExtendedIterator find(TriplePattern pattern)

  Basic pattern lookup interface. This implementation assumes that the underlying findWithContinuation will have also consulted the raw data.

  Parameters:
    `pattern` - a TriplePattern to be matched against the data
  Returns:
    a ExtendedIterator over all Triples in the data set that match the pattern

### setDerivationLogging

    public void setDerivationLogging(boolean logOn)

  Switch on/off drivation logging

  Specified by:
    `setDerivationLogging` in interface `InfGraph`

### getDerivation

    public java.util.Iterator getDerivation(Triple triple)

  Return the derivation of the given triple (which is the result of some previous find operation). Not all reasoneers will support derivations.

  Specified by:
    `getDerivation` in interface `InfGraph`
  Returns:
    an iterator over Derivation records or null if there is no derivation information available for this triple.

### graphBaseSize

    public int graphBaseSize()

  Return the number of triples in the just the base graph

  Overrides:
    `graphBaseSize` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### isEmpty

    public boolean isEmpty()

  Answer true iff this graph is empty. [Used to be in QueryHandler, but moved in here because it's a more primitive operation.]

  Specified by:
    `isEmpty` in interface `Graph`
  Overrides:
    `isEmpty` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### close

    public void close()

  Free all resources, any further use of this Graph is an error.

  Specified by:
    `close` in interface `Graph`
  Overrides:
    `close` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### getVersion

    public int getVersion()

  Return a version stamp for this graph which can be used to fast-fail concurrent modification exceptions.

### performAdd

    public void performAdd(Triple t)

  Add one triple to the data graph, run any rules triggered by the new data item, recursively adding any generated triples.

  Specified by:
    `performAdd` in interface `com.hp.hpl.jena.graph.impl.GraphWithPerform`
  Overrides:
    `performAdd` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### performDelete

    public void performDelete(Triple t)

  Removes the triple t (if possible) from the set belonging to this graph.

  Specified by:
    `performDelete` in interface `com.hp.hpl.jena.graph.impl.GraphWithPerform`
  Overrides:
    `performDelete` in class `com.hp.hpl.jena.graph.impl.GraphBase`

### getSchemaGraph

    public abstract Graph getSchemaGraph()

  Return the schema graph, if any, bound into this inference graph.

### cloneWithPremises

    public InfGraph cloneWithPremises(Graph premises)

  Return a new inference graph which is a clone of the current graph together with an additional set of data premises. The default implementation loses ALL partial deductions so far. Some subclasses may be able to a more efficient job.

### isPrepared

    public boolean isPrepared()

  Answer true iff this graph has been through the `prepare()` step. For testing purposes.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Hewlett-Packard Development Company, LP